"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mDNSSearch = void 0;
const bonjour = __importStar(require("bonjour"));
const DiscoveryLogger_1 = require("./DiscoveryLogger");
class mDNSSearch {
    constructor() {
        this.mdns = bonjour.default({});
    }
    search(timeout) {
        const self = this;
        // Queue up a search for services immediately
        this.browser = this.mdns.find({
            type: 'hue',
            protocol: 'tcp',
        });
        DiscoveryLogger_1.DiscoveryLogger.install('mDNS', this.browser);
        return new Promise((resolve) => {
            this.browser.start();
            // Await our timeout before returning any results
            setTimeout(() => {
                const allServices = self.browser.services;
                let results = [];
                if (allServices) {
                    resolve(allServices.map((service) => {
                        if (service.addresses) {
                            return {
                                internalipaddress: service.addresses[0],
                                id: service.fqdn,
                            };
                        }
                    }));
                }
                self.browser.stop();
                resolve(results);
            }, timeout || 5000);
        });
    }
    finished() {
        if (this.mdns) {
            this.mdns.destroy();
        }
    }
}
exports.mDNSSearch = mDNSSearch;
